#!/bin/bash

sourceFile="inputOutput.k";

################################################################################

echo && printf '=%.0s' {1..80} && echo;
echo -e "===== Mode Int + stdin =====\n";
rm -fr ./*-kompiled;

specSrcFile="inputOutput_Int_stdin.k";
sed -e 's|INPUTOUTPUT|INPUTOUTPUT_INT_STDIN|g' \
    -e 's|<inputs> $IN:List </inputs>|<inputs stream="stdin"> .List </inputs>|g' \
    -e 's|:DType|:Int|g' \
    ${sourceFile} > ${specSrcFile};

echo -e "=== Compile ... ===\n";
kompile ${specSrcFile};

echo -e "\n=== Run ... ===\n";
krun forward.prg < ints.data;

################################################################################

echo && printf '=%.0s' {1..80} && echo;
echo -e "===== Mode DType + stdin =====\n";
rm -fr ./*-kompiled;

specSrcFile="inputOutput_DType_stdin.k";
sed -e 's|INPUTOUTPUT|INPUTOUTPUT_DTYPE_STDIN|g' \
    -e 's|<inputs> $IN:List </inputs>|<inputs stream="stdin"> .List </inputs>|g' \
    -e 's|:DType|:DType|g' \
    ${sourceFile} > ${specSrcFile};

echo -e "=== Compile ... ===\n";
kompile ${specSrcFile};

echo -e "\n=== Run ... ===\n";
krun forward.prg < ints.data;

################################################################################

echo && printf '=%.0s' {1..80} && echo;
echo -e "===== Mode Int + IN =====\n";
rm -fr ./*-kompiled;

specSrcFile="inputOutput_Int_IN.k";
sed -e 's|INPUTOUTPUT|INPUTOUTPUT_INT_IN|g' \
    -e 's|<inputs stream="stdin"> .List </inputs>|<inputs> $IN:List </inputs>|g' \
    -e 's|:DType|:Int|g' \
    ${sourceFile} > ${specSrcFile};

echo -e "=== Compile ... ===\n";
kompile ${specSrcFile};

for f in "12.data" "intsColumn.data" "ints.data"; # dotData.data
do
    echo -e "\n=== Run with ${f} ... ===\n";
    krun -pIN="kast -s IntList" -cIN=${f} forward.prg;
done

################################################################################

echo && printf '=%.0s' {1..80} && echo;
echo -e "===== Mode DType + IN =====\n";
rm -fr ./*-kompiled;

specSrcFile="inputOutput_DType_IN.k";
sed -e 's|INPUTOUTPUT|INPUTOUTPUT_DTYPE_IN|g' \
    -e 's|<inputs stream="stdin"> .List </inputs>|<inputs> $IN:List </inputs>|g' \
    -e 's|:Int|:DType|g' \
    ${sourceFile} > ${specSrcFile};

echo -e "=== Compile ... ===\n";
kompile ${specSrcFile};

for f in "12.data" "intsColumn.data" "ints.data"; # dotData.data
do
    echo -e "\n=== Run with ${f} ... ===\n";
    krun -pIN="kast -s DTypeList" -cIN=${f} forward.prg;
done
